//+------------------------------------------------------------------+
//|                                                      ProjectName |
//|                                      Copyright 2012, CompanyName |
//|                                       http://www.companyname.net |
//+------------------------------------------------------------------+
#property version   "1.00"
#property strict
#property indicator_chart_window
#property indicator_buffers 1
#property indicator_plots   1
//--- plot s_ma
#property indicator_label1  "s_ma"
#property indicator_type1   DRAW_LINE
#property indicator_color1  clrOrange
#property indicator_style1  STYLE_SOLID
#property indicator_width1  2

//--- indicator buffers
double         s_maBuffer[];

//--- input parameters
input int                 s_ma_Period=13;
input int                 s_ma_Shift=0;
input ENUM_MA_METHOD      s_ma_Method=MODE_LWMA;
input ENUM_APPLIED_PRICE  s_ma_Price=PRICE_WEIGHTED;
extern int                Processed_Bars=100;

double s_ma_Array[];
datetime Time0;
double Pip_Points;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
//--- indicator buffers mapping
   IndicatorDigits(Digits);
   SetIndexBuffer(0,s_maBuffer);

   if(Processed_Bars>Bars-1) Processed_Bars=Bars-1;
   ArrayResize(s_ma_Array,Processed_Bars);
   ArrayInitialize(s_ma_Array,0);

   if(s_ma_Period<2)
     {
      Print("Wrong input parameter. s_ma_Period must be greater than 1.");
      return(INIT_FAILED);
     }

   for(int i=0;i<Processed_Bars;i++)
     {
      s_ma_Array[i]=Get_s_ma(Symbol(),0,s_ma_Period,s_ma_Method,s_ma_Price,i+s_ma_Shift);
     }

   Time0=Time[0];
   Pip_Points=SymbolInfoDouble(Symbol(),SYMBOL_POINT);

//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
//---
   Add_New_Bar();

   s_ma_Array[0]=Get_s_ma(Symbol(),0,s_ma_Period,s_ma_Method,s_ma_Price,s_ma_Shift);

   for(int i=0;i<Processed_Bars;i++)
     {
      s_maBuffer[i]=s_ma_Array[i];
     }

//--- return value of prev_calculated for next call
   return(rates_total);
  }
//+------------------------------------------------------------------+
double Get_s_ma(string symbol,int tframe,int s_ma_period,ENUM_MA_METHOD s_ma_method,ENUM_APPLIED_PRICE s_ma_price,int shift)
  {
   double s_ma;
   int i;
   int P_s_ma=(int)MathFloor(MathSqrt(s_ma_period));
   int MedP_s_ma=(int)MathFloor(s_ma_period/2);
   double Val1[];
   ArrayResize(Val1,P_s_ma);
   ArraySetAsSeries(Val1,true);
   ArrayInitialize(Val1,0);

   for(i=0; i<P_s_ma; i++)
     {
      Val1[i]=2*iMA(symbol,tframe,MedP_s_ma,0,s_ma_method,s_ma_price,shift+i)-iMA(symbol,tframe,s_ma_period,0,s_ma_method,s_ma_price,shift+i);
     }
   s_ma=iMAOnArray(Val1,0,P_s_ma,0,MODE_LWMA,0);

   return(s_ma);
  }
//+------------------------------------------------------------------+
void Add_New_Bar()
  {
   if(Time[0]!=Time0)
     {
      for(int i=Processed_Bars-1;i>0;i--)
        {
         s_ma_Array[i]=s_ma_Array[i-1];
        }
      Time0=Time[0];
     }
  }
//+------------------------------------------------------------------+
